
/**************************************
         MMC/SD access routines
 -------------------------------------
 Copyright 2011 David Guillen Fandos
 Use at your own risk!
 -------------------------------------
 Very rudimentary and not finished, 
 but yet functional and fast.
***************************************/

#include <pic18fregs.h>
#include "macros.h"
#include "spi.h"

void InitSDCard() {
	int i, timeout;
	unsigned char read;

	enable_spi_master(1, 0, 1, 0x2);

	PORTA = 1;  // CS = FALSE
	for (i = 0; i < 1000; i++);  // WAIT
	PORTA = 0;  // CS = TRUE
	for (i = 0; i < 1000; i++);  // WAIT

	do {
		spi_sync_send(0x40);
		spi_sync_send(0x00);
		spi_sync_send(0x00);
		spi_sync_send(0x00);
		spi_sync_send(0x00);
		spi_sync_send(0x95);
	
		// WAIT FOR AN OK (0x1)
		timeout = 300;
		do {
			read = spi_sync_send(0xFF);
		} while (read != 0x1 && (--timeout));
	}while (timeout == 0);


	do {
		spi_sync_send(0x41);
		spi_sync_send(0x00);
		spi_sync_send(0x00);
		spi_sync_send(0x00);
		spi_sync_send(0x00);
		spi_sync_send(0xFF);
	
		// WAIT FOR AN OK (0x1)
		timeout = 100;
		do {
			read = spi_sync_send(0xFF);
		} while (read != 0x00 && (--timeout));
	}while (timeout == 0);

	enable_spi_master(1, 0, 1, 0);
}

void ReadSDBlock(char * buffer, unsigned long block_num) {
	unsigned char read;
	short i,timeout;
	while(spi_sync_send(0xFF) == 0x00);
	block_num = (block_num<<9);
	do {
		spi_sync_send(0x51); // CMD17
		spi_sync_send(block_num>>24);
		spi_sync_send(block_num>>16);
		spi_sync_send(block_num>>8);
		spi_sync_send(block_num);
		spi_sync_send(0xFF);  // BAD CRC ;)
	
		// WAIT FOR START TOKEN
		timeout = 600;
		do {
			read = spi_sync_send(0xFF);
		} while (((unsigned char)read) != 0xFE && (--timeout));
	} while (timeout == 0);

	spi_sync_buf_rcv(buffer,512);

	spi_sync_send(0xFF);
	spi_sync_send(0xFF);
}


void WriteSDBlock(char * buffer, unsigned long block_num) {
	unsigned char read;
	short i,timeout;
	while(spi_sync_send(0xFF) == 0x00);
	block_num = (block_num<<9);
	do {
		spi_sync_send(0x58);  // CMD24
		spi_sync_send(block_num>>24);
		spi_sync_send(block_num>>16);
		spi_sync_send(block_num>>8);
		spi_sync_send(block_num);
		spi_sync_send(0xFF);  // BAD CRC ;)
	
		// WAIT FOR RESPONSE
		timeout = 600;
		do {
			read = spi_sync_send(0xFF);
		} while (((unsigned char)read) != 0x00 && (--timeout));
	} while (timeout == 0);

	spi_sync_send(0xFF);
	spi_sync_send(0xFE);
	spi_sync_buf_snd(buffer,512);

	spi_sync_send(0x00);  // CRC
	spi_sync_send(0x00);

	read = spi_sync_send(0xFF);
	read = spi_sync_send(0xFF);
}



